package org.dasein.cloud.test;

import java.io.IOException;

import org.dasein.cloud.CloudException;
import org.dasein.cloud.CloudProvider;
import org.dasein.cloud.InternalException;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class MinimumFunctionalityTestCase extends BaseTestCase {
    private CloudProvider provider = null;
    
    public MinimumFunctionalityTestCase(String name) { super(name); }
    
    @Before
    @Override
    public void setUp() throws CloudException, InternalException, InstantiationException, IllegalAccessException, IOException {
        provider = getProvider();
        provider.connect(getTestContext());
    }
    
    @After
    @Override
    public void tearDown() {
        if( provider != null ) {
            provider.close();
        }
    }

    @Test
    public void testConfiguration() {
        assertNotNull("Cloud name must be specified", provider.getCloudName());
        assertNotNull("Provider name must be specified", provider.getProviderName());
    }
    
    @Test
    public void testDataCenterService() {
        assertNotNull("All Dasein Cloud implementations must support data center services", provider.getDataCenterServices());
    }
}
